]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
Merge 'u-boot-imx/master' into 'u-boot-arm/master'
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5 #
6 # SPDX-License-Identifier: GPL-2.0+
7
8 usage()
9 {
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
35
36 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1)
47
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61 }
62
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
65
66 # Option processing based on util-linux-2.13/getopt-parse.bash
67
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
71 # getopt.
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"`
74
75 [ $? != 0 ] && usage 1
76
77 # Note the quotes around `$TEMP': they are essential!
78 eval set -- "$TEMP"
79
80 SELECTED=''
81 ONLY_LIST=''
82 PRINT_MAINTS=''
83 MAINTAINERS_ONLY=''
84 CONTINUE=''
85 REBUILD_ERRORS=''
86
87 while true ; do
88 case "$1" in
89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else
94 opt_a="(\$2 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
102 else
103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -s|--soc)
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
111 else
112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
113 fi
114 SELECTED='y'
115 shift 2 ;;
116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else
121 opt_v="(\$5 == \"$2\")"
122 fi
123 SELECTED='y'
124 shift 2 ;;
125 -b|--board)
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi
134 SELECTED='y'
135 shift 2 ;;
136 -C|--check)
137 CHECK='C=1'
138 shift ;;
139 -n|--continue)
140 CONTINUE='y'
141 shift ;;
142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y'
144 shift ;;
145 -l|--list)
146 ONLY_LIST='y'
147 shift ;;
148 -m|--maintainers)
149 ONLY_LIST='y'
150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y'
152 shift ;;
153 -M|--mails)
154 ONLY_LIST='y'
155 PRINT_MAINTS='y'
156 shift ;;
157 -h|--help)
158 usage ;;
159 --)
160 shift ; break ;;
161 *)
162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac
164 done
165 # echo "Remaining arguments:"
166 # for arg do echo '--> '"\`$arg'" ; done
167
168 FILTER="\$1 !~ /^#/"
169 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
170 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
171 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
172 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
173 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
174
175 if [ "$SELECTED" ] ; then
176 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
177
178 # Make sure some boards from boards.cfg are actually found
179 if [ -z "$SELECTED" ] ; then
180 echo "Error: No boards selected, invalid arguments"
181 exit 1
182 fi
183 fi
184
185 #########################################################################
186
187 # Print statistics when we exit
188 trap exit 1 2 3 15
189 trap print_stats 0
190
191 # Determine number of CPU cores if no default was set
192 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
193
194 if [ "$BUILD_NCPUS" -gt 1 ]
195 then
196 JOBS="-j $((BUILD_NCPUS + 1))"
197 else
198 JOBS=""
199 fi
200
201 if [ "${MAKEALL_LOGDIR}" ] ; then
202 LOG_DIR=${MAKEALL_LOGDIR}
203 else
204 LOG_DIR="LOG"
205 fi
206
207 : ${BUILD_NBUILDS:=1}
208 BUILD_MANY=0
209
210 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
211 BUILD_MANY=1
212 : ${BUILD_DIR:=./build}
213 mkdir -p "${BUILD_DIR}/ERR"
214 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
215 fi
216
217 : ${BUILD_DIR:=.}
218
219 OUTPUT_PREFIX="${BUILD_DIR}"
220
221 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
222 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
223 find "${LOG_DIR}/" -type f -exec rm -f {} +
224 fi
225
226 LIST=""
227
228 # Keep track of the number of builds and errors
229 ERR_CNT=0
230 ERR_LIST=""
231 WRN_CNT=0
232 WRN_LIST=""
233 TOTAL_CNT=0
234 SKIP_CNT=0
235 CURRENT_CNT=0
236 OLDEST_IDX=1
237 RC=0
238
239 # Helper funcs for parsing boards.cfg
240 targets_by_field()
241 {
242 field=$1
243 regexp=$2
244
245 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
246 boards.cfg
247 }
248
249 targets_by_arch() { targets_by_field 2 "$@" ; }
250 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
251 targets_by_soc() { targets_by_field 4 "$@" ; }
252
253 #########################################################################
254 ## MPC5xx Systems
255 #########################################################################
256
257 LIST_5xx="$(targets_by_cpu mpc5xx)"
258
259 #########################################################################
260 ## MPC5xxx Systems
261 #########################################################################
262
263 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
264
265 #########################################################################
266 ## MPC512x Systems
267 #########################################################################
268
269 LIST_512x="$(targets_by_cpu mpc512x)"
270
271 #########################################################################
272 ## MPC8xx Systems
273 #########################################################################
274
275 LIST_8xx="$(targets_by_cpu mpc8xx)"
276
277 #########################################################################
278 ## PPC4xx Systems
279 #########################################################################
280
281 LIST_4xx="$(targets_by_cpu ppc4xx)"
282
283 #########################################################################
284 ## MPC824x Systems
285 #########################################################################
286
287 LIST_824x="$(targets_by_cpu mpc824x)"
288
289 #########################################################################
290 ## MPC8260 Systems (includes 8250, 8255 etc.)
291 #########################################################################
292
293 LIST_8260="$(targets_by_cpu mpc8260)"
294
295 #########################################################################
296 ## MPC83xx Systems (includes 8349, etc.)
297 #########################################################################
298
299 LIST_83xx="$(targets_by_cpu mpc83xx)"
300
301 #########################################################################
302 ## MPC85xx Systems (includes 8540, 8560 etc.)
303 #########################################################################
304
305 LIST_85xx="$(targets_by_cpu mpc85xx)"
306
307 #########################################################################
308 ## MPC86xx Systems
309 #########################################################################
310
311 LIST_86xx="$(targets_by_cpu mpc86xx)"
312
313 #########################################################################
314 ## 74xx/7xx Systems
315 #########################################################################
316
317 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
318
319 #########################################################################
320 ## PowerPC groups
321 #########################################################################
322
323 LIST_TSEC=" \
324 ${LIST_83xx} \
325 ${LIST_85xx} \
326 ${LIST_86xx} \
327 "
328
329 LIST_powerpc=" \
330 ${LIST_5xx} \
331 ${LIST_512x} \
332 ${LIST_5xxx} \
333 ${LIST_8xx} \
334 ${LIST_824x} \
335 ${LIST_8260} \
336 ${LIST_83xx} \
337 ${LIST_85xx} \
338 ${LIST_86xx} \
339 ${LIST_4xx} \
340 ${LIST_74xx_7xx}\
341 "
342
343 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
344 # still using "ppc" instead of "powerpc"
345 LIST_ppc=" \
346 ${LIST_powerpc} \
347 "
348
349 #########################################################################
350 ## StrongARM Systems
351 #########################################################################
352
353 LIST_SA="$(targets_by_cpu sa1100)"
354
355 #########################################################################
356 ## ARM7 Systems
357 #########################################################################
358
359 LIST_ARM7="$(targets_by_cpu arm720t)"
360
361 #########################################################################
362 ## ARM9 Systems
363 #########################################################################
364
365 LIST_ARM9="$(targets_by_cpu arm920t) \
366 $(targets_by_cpu arm926ejs) \
367 $(targets_by_cpu arm946es) \
368 "
369
370 #########################################################################
371 ## ARM11 Systems
372 #########################################################################
373 LIST_ARM11="$(targets_by_cpu arm1136) \
374 $(targets_by_cpu arm1176) \
375 "
376
377 #########################################################################
378 ## ARMV7 Systems
379 #########################################################################
380
381 LIST_ARMV7="$(targets_by_cpu armv7)"
382
383 #########################################################################
384 ## ARMV8 Systems
385 #########################################################################
386
387 LIST_ARMV8="$(targets_by_cpu armv8)"
388
389 #########################################################################
390 ## AT91 Systems
391 #########################################################################
392
393 LIST_at91="$(targets_by_soc at91)"
394
395 #########################################################################
396 ## Xscale Systems
397 #########################################################################
398
399 LIST_pxa="$(targets_by_cpu pxa)"
400
401 LIST_ixp="$(targets_by_cpu ixp)"
402
403 #########################################################################
404 ## SPEAr Systems
405 #########################################################################
406
407 LIST_spear="$(targets_by_soc spear)"
408
409 #########################################################################
410 ## ARM groups
411 #########################################################################
412
413 LIST_arm="$(targets_by_arch arm | \
414 for ARMV8_TARGET in $LIST_ARMV8; \
415 do sed "/$ARMV8_TARGET/d"; \
416 done) \
417 "
418
419 #########################################################################
420 ## MIPS Systems (default = big endian)
421 #########################################################################
422
423 LIST_mips4kc=" \
424 incaip \
425 incaip_100MHz \
426 incaip_133MHz \
427 incaip_150MHz \
428 qemu_mips \
429 vct_platinum \
430 vct_platinum_small \
431 vct_platinum_onenand \
432 vct_platinum_onenand_small \
433 vct_platinumavc \
434 vct_platinumavc_small \
435 vct_platinumavc_onenand \
436 vct_platinumavc_onenand_small \
437 vct_premium \
438 vct_premium_small \
439 vct_premium_onenand \
440 vct_premium_onenand_small \
441 "
442
443 LIST_au1xx0=" \
444 dbau1000 \
445 dbau1100 \
446 dbau1500 \
447 dbau1550 \
448 "
449
450 LIST_mips=" \
451 ${LIST_mips4kc} \
452 ${LIST_mips5kc} \
453 ${LIST_au1xx0} \
454 "
455
456 #########################################################################
457 ## MIPS Systems (little endian)
458 #########################################################################
459
460 LIST_au1xx0_el=" \
461 dbau1550_el \
462 pb1000 \
463 "
464 LIST_mips_el=" \
465 ${LIST_au1xx0_el} \
466 "
467 #########################################################################
468 ## OpenRISC Systems
469 #########################################################################
470
471 LIST_openrisc="$(targets_by_arch openrisc)"
472
473 #########################################################################
474 ## x86 Systems
475 #########################################################################
476
477 LIST_x86="$(targets_by_arch x86)"
478
479 #########################################################################
480 ## Nios-II Systems
481 #########################################################################
482
483 LIST_nios2="$(targets_by_arch nios2)"
484
485 #########################################################################
486 ## MicroBlaze Systems
487 #########################################################################
488
489 LIST_microblaze="$(targets_by_arch microblaze)"
490
491 #########################################################################
492 ## ColdFire Systems
493 #########################################################################
494
495 LIST_m68k="$(targets_by_arch m68k)"
496 LIST_coldfire=${LIST_m68k}
497
498 #########################################################################
499 ## AVR32 Systems
500 #########################################################################
501
502 LIST_avr32="$(targets_by_arch avr32)"
503
504 #########################################################################
505 ## Blackfin Systems
506 #########################################################################
507
508 LIST_blackfin="$(targets_by_arch blackfin)"
509
510 #########################################################################
511 ## SH Systems
512 #########################################################################
513
514 LIST_sh2="$(targets_by_cpu sh2)"
515 LIST_sh3="$(targets_by_cpu sh3)"
516 LIST_sh4="$(targets_by_cpu sh4)"
517
518 LIST_sh="$(targets_by_arch sh)"
519
520 #########################################################################
521 ## SPARC Systems
522 #########################################################################
523
524 LIST_sparc="$(targets_by_arch sparc)"
525
526 #########################################################################
527 ## NDS32 Systems
528 #########################################################################
529
530 LIST_nds32="$(targets_by_arch nds32)"
531
532 #-----------------------------------------------------------------------
533
534 get_target_location() {
535 local target=$1
536 local BOARD_NAME=""
537 local CONFIG_NAME=""
538 local board=""
539 local vendor=""
540
541 # Automatic mode
542 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
543 if [ -z "${line}" ] ; then echo "" ; return ; fi
544
545 set ${line}
546
547 CONFIG_NAME="${7%_config}"
548
549 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_config}"
550
551 if [ $# -gt 5 ]; then
552 if [ "$6" = "-" ] ; then
553 board=${BOARD_NAME}
554 else
555 board="$6"
556 fi
557 fi
558
559 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
560 [ $# -gt 6 ] && [ "$8" != "-" ] && {
561 tmp="${8%:*}"
562 if [ "$tmp" ] ; then
563 CONFIG_NAME="$tmp"
564 fi
565 }
566
567 # Assign board directory to BOARDIR variable
568 if [ "${vendor}" == "-" ] ; then
569 BOARDDIR=${board}
570 else
571 BOARDDIR=${vendor}/${board}
572 fi
573
574 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
575 }
576
577 get_target_maintainers() {
578 local name=`echo $1 | cut -d : -f 3`
579
580 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
581 if [ -z "${line}" ]; then
582 echo ""
583 return ;
584 fi
585
586 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
587 [ "$mails" == "-" ] && mails=""
588 echo "$mails"
589 }
590
591 get_target_arch() {
592 local target=$1
593
594 # Automatic mode
595 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
596
597 if [ -z "${line}" ] ; then echo "" ; return ; fi
598
599 set ${line}
600 echo "$2"
601 }
602
603 list_target() {
604 if [ "$PRINT_MAINTS" != 'y' ] ; then
605 echo "$1"
606 return
607 fi
608
609 echo -n "$1:"
610
611 local loc=`get_target_location $1`
612
613 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
614
615 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
616
617 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
618
619 local dir=`echo ${loc} | cut -d ":" -f 2`
620 local cfg=`echo ${loc} | cut -d ":" -f 1`
621 local git_result=`git log --format=%aE board/${dir} \
622 include/configs/${cfg}.h | grep "@"`
623 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
624 head -n 3`
625 local git_result_top=`echo ${git_result} | tr " " "\n" | \
626 sort | uniq -c | sort -nr | head -n 3 | \
627 sed "s/^ \+[0-9]\+ \+//"`
628
629 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
630 sort -u | tr "\n" " " | sed "s/ $//" ;
631 else
632 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
633 sed "s/ $//" ;
634 fi
635
636 echo ""
637 }
638
639 # Each finished build will have a file called ${donep}${n},
640 # where n is the index of the build. Each build
641 # we've already noted as finished will have ${skipp}${n}.
642 # The code managing the build process will use this information
643 # to ensure that only BUILD_NBUILDS builds are in flight at once
644 donep="${LOG_DIR}/._done_"
645 skipp="${LOG_DIR}/._skip_"
646
647 build_target_killed() {
648 echo "Aborted $target build."
649 # Remove the logs for this board since it was aborted
650 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
651 exit
652 }
653
654 build_target() {
655 target=$1
656 build_idx=$2
657
658 if [ "$ONLY_LIST" == 'y' ] ; then
659 list_target ${target}
660 return
661 fi
662
663 if [ $BUILD_MANY == 1 ] ; then
664 output_dir="${OUTPUT_PREFIX}/${target}"
665 mkdir -p "${output_dir}"
666 trap build_target_killed TERM
667 else
668 output_dir="${OUTPUT_PREFIX}"
669 fi
670
671 export BUILD_DIR="${output_dir}"
672
673 target_arch=$(get_target_arch ${target})
674 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
675 if [ "${cross_toolchain}" ] ; then
676 MAKE="make CROSS_COMPILE=${cross_toolchain}"
677 elif [ "${CROSS_COMPILE}" ] ; then
678 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
679 else
680 MAKE=make
681 fi
682
683 ${MAKE} distclean >/dev/null
684 ${MAKE} -s ${target}_config
685
686 ${MAKE} ${JOBS} ${CHECK} all \
687 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
688
689 # Check for 'make' errors
690 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
691 RC=1
692 fi
693
694 if [ $BUILD_MANY == 1 ] ; then
695 trap - TERM
696
697 ${MAKE} -s tidy
698
699 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
700 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
701 else
702 rm ${LOG_DIR}/${target}.ERR
703 fi
704 else
705 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
706 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
707 : $(( ERR_CNT += 1 ))
708 ERR_LIST="${ERR_LIST} $target"
709 else
710 : $(( WRN_CNT += 1 ))
711 WRN_LIST="${WRN_LIST} $target"
712 fi
713 else
714 rm ${LOG_DIR}/${target}.ERR
715 fi
716 fi
717
718 OBJS=${output_dir}/u-boot
719 if [ -e ${output_dir}/spl/u-boot-spl ]; then
720 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
721 fi
722
723 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
724
725 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
726
727 touch "${donep}${build_idx}"
728 }
729
730 manage_builds() {
731 search_idx=${OLDEST_IDX}
732 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
733
734 while true; do
735 if [ -e "${donep}${search_idx}" ] ; then
736 : $(( CURRENT_CNT-- ))
737 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
738 : $(( OLDEST_IDX++ ))
739
740 # Only want to count it once
741 rm -f "${donep}${search_idx}"
742 touch "${skipp}${search_idx}"
743 elif [ -e "${skipp}${search_idx}" ] ; then
744 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
745 : $(( OLDEST_IDX++ ))
746 fi
747 : $(( search_idx++ ))
748 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
749 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
750 search_idx=${OLDEST_IDX}
751 sleep 1
752 else
753 break
754 fi
755 fi
756 done
757 }
758
759 build_targets() {
760 for t in "$@" ; do
761 # If a LIST_xxx var exists, use it. But avoid variable
762 # expansion in the eval when a board name contains certain
763 # characters that the shell interprets.
764 case ${t} in
765 *[-+=]*) list= ;;
766 *) list=$(eval echo '${LIST_'$t'}') ;;
767 esac
768 if [ -n "${list}" ] ; then
769 build_targets ${list}
770 else
771 : $((TOTAL_CNT += 1))
772 : $((CURRENT_CNT += 1))
773 rm -f "${donep}${TOTAL_CNT}"
774 rm -f "${skipp}${TOTAL_CNT}"
775 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
776 : $((SKIP_CNT += 1))
777 touch "${donep}${TOTAL_CNT}"
778 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
779 : $((SKIP_CNT += 1))
780 touch "${donep}${TOTAL_CNT}"
781 else
782 if [ $BUILD_MANY == 1 ] ; then
783 build_target ${t} ${TOTAL_CNT} &
784 else
785 CUR_TGT="${t}"
786 build_target ${t} ${TOTAL_CNT}
787 CUR_TGT=''
788 fi
789 fi
790 fi
791
792 # We maintain a running count of all the builds we have done.
793 # Each finished build will have a file called ${donep}${n},
794 # where n is the index of the build. Each build
795 # we've already noted as finished will have ${skipp}${n}.
796 # We track the current index via TOTAL_CNT, and the oldest
797 # index. When we exceed the maximum number of parallel builds,
798 # We look from oldest to current for builds that have completed,
799 # and update the current count and oldest index as appropriate.
800 # If we've gone through the entire list, wait a second, and
801 # reprocess the entire list until we find a build that has
802 # completed
803 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
804 manage_builds
805 fi
806 done
807 }
808
809 #-----------------------------------------------------------------------
810
811 kill_children() {
812 local OS=$(uname -s)
813 local children=""
814 case "${OS}" in
815 "Darwin")
816 # Mac OS X is known to have BSD style ps
817 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
818 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
819 ;;
820 *)
821 # everything else tries the GNU style
822 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
823 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
824 ;;
825 esac
826
827 kill $children 2> /dev/null
828 wait $children 2> /dev/null
829
830 exit
831 }
832
833 print_stats() {
834 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
835
836 # Only count boards that completed
837 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
838
839 rm -f ${donep}* ${skipp}*
840
841 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
842 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
843 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
844 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
845 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
846 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
847 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
848 else
849 # Remove the logs for any board that was interrupted
850 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
851 fi
852
853 : $((TOTAL_CNT -= ${SKIP_CNT}))
854 echo ""
855 echo "--------------------- SUMMARY ----------------------------"
856 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
857 echo "Boards skipped: ${SKIP_CNT}"
858 fi
859 echo "Boards compiled: ${TOTAL_CNT}"
860 if [ ${ERR_CNT} -gt 0 ] ; then
861 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
862 fi
863 if [ ${WRN_CNT} -gt 0 ] ; then
864 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
865 fi
866 echo "----------------------------------------------------------"
867
868 if [ $BUILD_MANY == 1 ] ; then
869 kill_children
870 fi
871
872 exit $RC
873 }
874
875 #-----------------------------------------------------------------------
876
877 # Build target groups selected by options, plus any command line args
878 set -- ${SELECTED} "$@"
879 # run PowerPC by default
880 [ $# = 0 ] && set -- powerpc
881 build_targets "$@"
882 wait